Package org.lwjgl.opengl

# Class ARBShaderObjects

java.lang.Object
org.lwjgl.opengl.ARBShaderObjects

public final class ARBShaderObjects extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`GL_BOOL_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC2_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC3_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC4_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_MAT2_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_MAT3_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_MAT4_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC2_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC3_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC4_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_INT_VEC2_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_INT_VEC3_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_INT_VEC4_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_ACTIVE_UNIFORMS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_ATTACHED_OBJECTS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_COMPILE_STATUS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_DELETE_STATUS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_INFO_LOG_LENGTH_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_LINK_STATUS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_SHADER_SOURCE_LENGTH_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_SUBTYPE_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_TYPE_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_OBJECT_VALIDATE_STATUS_ARB`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_PROGRAM_OBJECT_ARB`
Accepted by the <pname> argument of GetHandleARB:
`static final int`
`GL_SAMPLER_1D_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_1D_SHADOW_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D_RECT_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D_RECT_SHADOW_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D_SHADOW_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_3D_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_CUBE_ARB`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SHADER_OBJECT_ARB`
Returned by the <params> parameter of GetObjectParameter{fi}vARB:

## Method Summary

Modifier and Type
Method
Description
`static void`
`glAttachObjectARB(int containerObj, int obj)`
`static void`
`glCompileShaderARB(int shaderObj)`
`static int`
`glCreateProgramObjectARB()`
`static int`
`glCreateShaderObjectARB(int shaderType)`
`static void`
`glDeleteObjectARB(int obj)`
`static void`
`glDetachObjectARB(int containerObj, int attachedObj)`
`static String`
`glGetActiveUniformARB(int programObj, int index, int maxLength)`
Overloads glGetActiveUniformARB.
`static String`
`glGetActiveUniformARB(int programObj, int index, int maxLength, IntBuffer sizeType)`
Overloads glGetActiveUniformARB.
`static void`
`glGetActiveUniformARB(int programObj, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)`
`static int`
`glGetActiveUniformSizeARB(int programObj, int index)`
Overloads glGetActiveUniformARB.
`static int`
`glGetActiveUniformTypeARB(int programObj, int index)`
Overloads glGetActiveUniformARB.
`static void`
`glGetAttachedObjectsARB(int containerObj, IntBuffer count, IntBuffer obj)`
`static int`
`glGetHandleARB(int pname)`
`static String`
`glGetInfoLogARB(int obj, int maxLength)`
Overloads glGetInfoLogARB.
`static void`
`glGetInfoLogARB(int obj, IntBuffer length, ByteBuffer infoLog)`
`static void`
`glGetObjectParameterARB(int obj, int pname, FloatBuffer params)`
`static void`
`glGetObjectParameterARB(int obj, int pname, IntBuffer params)`
`static float`
`glGetObjectParameterfARB(int obj, int pname)`
Overloads glGetObjectParameterfvARB.
`static int`
`glGetObjectParameteriARB(int obj, int pname)`
Overloads glGetObjectParameterivARB.
`static String`
`glGetShaderSourceARB(int obj, int maxLength)`
Overloads glGetShaderSourceARB.
`static void`
`glGetShaderSourceARB(int obj, IntBuffer length, ByteBuffer source)`
`static void`
`glGetUniformARB(int programObj, int location, FloatBuffer params)`
`static void`
`glGetUniformARB(int programObj, int location, IntBuffer params)`
`static int`
`glGetUniformLocationARB(int programObj, CharSequence name)`
Overloads glGetUniformLocationARB.
`static int`
`glGetUniformLocationARB(int programObj, ByteBuffer name)`
Returns the location of the uniform with the specified name.
`static void`
`glLinkProgramARB(int programObj)`
`static void`
`glShaderSourceARB(int shader, CharSequence string)`
Overloads glShaderSourceARB.
`static void`
`glShaderSourceARB(int shader, CharSequence[] strings)`
Overloads glShaderSourceARB.
`static void`
`glShaderSourceARB(int shader, ByteBuffer string)`
The ARB_shader_objects extension allows multiple, optionally null-terminated, source strings to define a shader program.
`static void`
`glUniform1ARB(int location, FloatBuffer values)`
`static void`
`glUniform1ARB(int location, IntBuffer values)`
`static void`
`glUniform1fARB(int location, float v0)`
`static void`
`glUniform1iARB(int location, int v0)`
`static void`
`glUniform2ARB(int location, FloatBuffer values)`
`static void`
`glUniform2ARB(int location, IntBuffer values)`
`static void`
`glUniform2fARB(int location, float v0, float v1)`
`static void`
`glUniform2iARB(int location, int v0, int v1)`
`static void`
`glUniform3ARB(int location, FloatBuffer values)`
`static void`
`glUniform3ARB(int location, IntBuffer values)`
`static void`
`glUniform3fARB(int location, float v0, float v1, float v2)`
`static void`
`glUniform3iARB(int location, int v0, int v1, int v2)`
`static void`
`glUniform4ARB(int location, FloatBuffer values)`
`static void`
`glUniform4ARB(int location, IntBuffer values)`
`static void`
`glUniform4fARB(int location, float v0, float v1, float v2, float v3)`
`static void`
`glUniform4iARB(int location, int v0, int v1, int v2, int v3)`
`static void`
`glUniformMatrix2ARB(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUniformMatrix3ARB(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUniformMatrix4ARB(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUseProgramObjectARB(int programObj)`
`static void`
`glValidateProgramARB(int programObj)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### GL_PROGRAM_OBJECT_ARB

public static final int GL_PROGRAM_OBJECT_ARB
Accepted by the <pname> argument of GetHandleARB:

See Also:
  - Constant Field Values

### GL_OBJECT_TYPE_ARB

public static final int GL_OBJECT_TYPE_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_SUBTYPE_ARB

public static final int GL_OBJECT_SUBTYPE_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_DELETE_STATUS_ARB

public static final int GL_OBJECT_DELETE_STATUS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_COMPILE_STATUS_ARB

public static final int GL_OBJECT_COMPILE_STATUS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_LINK_STATUS_ARB

public static final int GL_OBJECT_LINK_STATUS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_VALIDATE_STATUS_ARB

public static final int GL_OBJECT_VALIDATE_STATUS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_INFO_LOG_LENGTH_ARB

public static final int GL_OBJECT_INFO_LOG_LENGTH_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_ATTACHED_OBJECTS_ARB

public static final int GL_OBJECT_ATTACHED_OBJECTS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_ACTIVE_UNIFORMS_ARB

public static final int GL_OBJECT_ACTIVE_UNIFORMS_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB

public static final int GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_OBJECT_SHADER_SOURCE_LENGTH_ARB

public static final int GL_OBJECT_SHADER_SOURCE_LENGTH_ARB
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_SHADER_OBJECT_ARB

public static final int GL_SHADER_OBJECT_ARB
Returned by the <params> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC2_ARB

public static final int GL_FLOAT_VEC2_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC3_ARB

public static final int GL_FLOAT_VEC3_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC4_ARB

public static final int GL_FLOAT_VEC4_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC2_ARB

public static final int GL_INT_VEC2_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC3_ARB

public static final int GL_INT_VEC3_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC4_ARB

public static final int GL_INT_VEC4_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_ARB

public static final int GL_BOOL_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC2_ARB

public static final int GL_BOOL_VEC2_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC3_ARB

public static final int GL_BOOL_VEC3_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC4_ARB

public static final int GL_BOOL_VEC4_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT2_ARB

public static final int GL_FLOAT_MAT2_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT3_ARB

public static final int GL_FLOAT_MAT3_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT4_ARB

public static final int GL_FLOAT_MAT4_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_1D_ARB

public static final int GL_SAMPLER_1D_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_ARB

public static final int GL_SAMPLER_2D_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_3D_ARB

public static final int GL_SAMPLER_3D_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_CUBE_ARB

public static final int GL_SAMPLER_CUBE_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_1D_SHADOW_ARB

public static final int GL_SAMPLER_1D_SHADOW_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_SHADOW_ARB

public static final int GL_SAMPLER_2D_SHADOW_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_RECT_ARB

public static final int GL_SAMPLER_2D_RECT_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_RECT_SHADOW_ARB

public static final int GL_SAMPLER_2D_RECT_SHADOW_ARB
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

## Method Details

### glDeleteObjectARB

public static void glDeleteObjectARB(int obj)

### glGetHandleARB

public static int glGetHandleARB(int pname)

### glDetachObjectARB

public static void glDetachObjectARB(int containerObj, int attachedObj)

### glCreateShaderObjectARB

public static int glCreateShaderObjectARB(int shaderType)

### glShaderSourceARB

public static void glShaderSourceARB(int shader, ByteBuffer string)
The ARB_shader_objects extension allows multiple, optionally null-terminated, source strings to define a shader program.

This method uses just a single string, that should NOT be null-terminated.

### glShaderSourceARB

public static void glShaderSourceARB(int shader, CharSequence string)
Overloads glShaderSourceARB.

### glShaderSourceARB

public static void glShaderSourceARB(int shader, CharSequence[] strings)
Overloads glShaderSourceARB.

### glCompileShaderARB

public static void glCompileShaderARB(int shaderObj)

### glCreateProgramObjectARB

public static int glCreateProgramObjectARB()

### glAttachObjectARB

public static void glAttachObjectARB(int containerObj, int obj)

### glLinkProgramARB

public static void glLinkProgramARB(int programObj)

### glUseProgramObjectARB

public static void glUseProgramObjectARB(int programObj)

### glValidateProgramARB

public static void glValidateProgramARB(int programObj)

### glUniform1fARB

public static void glUniform1fARB(int location, float v0)

### glUniform2fARB

public static void glUniform2fARB(int location, float v0, float v1)

### glUniform3fARB

public static void glUniform3fARB(int location, float v0, float v1, float v2)

### glUniform4fARB

public static void glUniform4fARB(int location, float v0, float v1, float v2, float v3)

### glUniform1iARB

public static void glUniform1iARB(int location, int v0)

### glUniform2iARB

public static void glUniform2iARB(int location, int v0, int v1)

### glUniform3iARB

public static void glUniform3iARB(int location, int v0, int v1, int v2)

### glUniform4iARB

public static void glUniform4iARB(int location, int v0, int v1, int v2, int v3)

### glUniform1ARB

public static void glUniform1ARB(int location, FloatBuffer values)

### glUniform2ARB

public static void glUniform2ARB(int location, FloatBuffer values)

### glUniform3ARB

public static void glUniform3ARB(int location, FloatBuffer values)

### glUniform4ARB

public static void glUniform4ARB(int location, FloatBuffer values)

### glUniform1ARB

public static void glUniform1ARB(int location, IntBuffer values)

### glUniform2ARB

public static void glUniform2ARB(int location, IntBuffer values)

### glUniform3ARB

public static void glUniform3ARB(int location, IntBuffer values)

### glUniform4ARB

public static void glUniform4ARB(int location, IntBuffer values)

### glUniformMatrix2ARB

public static void glUniformMatrix2ARB(int location, boolean transpose, FloatBuffer matrices)

### glUniformMatrix3ARB

public static void glUniformMatrix3ARB(int location, boolean transpose, FloatBuffer matrices)

### glUniformMatrix4ARB

public static void glUniformMatrix4ARB(int location, boolean transpose, FloatBuffer matrices)

### glGetObjectParameterARB

public static void glGetObjectParameterARB(int obj, int pname, FloatBuffer params)

### glGetObjectParameterfARB

public static float glGetObjectParameterfARB(int obj, int pname)
Overloads glGetObjectParameterfvARB.

### glGetObjectParameterARB

public static void glGetObjectParameterARB(int obj, int pname, IntBuffer params)

### glGetObjectParameteriARB

public static int glGetObjectParameteriARB(int obj, int pname)
Overloads glGetObjectParameterivARB.

### glGetInfoLogARB

public static void glGetInfoLogARB(int obj, IntBuffer length, ByteBuffer infoLog)

### glGetInfoLogARB

public static String glGetInfoLogARB(int obj, int maxLength)
Overloads glGetInfoLogARB.

### glGetAttachedObjectsARB

public static void glGetAttachedObjectsARB(int containerObj, IntBuffer count, IntBuffer obj)

### glGetUniformLocationARB

public static int glGetUniformLocationARB(int programObj, ByteBuffer name)
Returns the location of the uniform with the specified name. The ByteBuffer should contain the uniform name as a null-terminated string.

Parameters:
  `programObj` -
  `name` -

### glGetUniformLocationARB

public static int glGetUniformLocationARB(int programObj, CharSequence name)
Overloads glGetUniformLocationARB.

### glGetActiveUniformARB

public static void glGetActiveUniformARB(int programObj, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)

### glGetActiveUniformARB

public static String glGetActiveUniformARB(int programObj, int index, int maxLength, IntBuffer sizeType)
Overloads glGetActiveUniformARB.

Overloads glGetActiveUniformARB. This version returns both size and type in the sizeType buffer (at .position() and .position() + 1).

### glGetActiveUniformARB

public static String glGetActiveUniformARB(int programObj, int index, int maxLength)
Overloads glGetActiveUniformARB.

Overloads glGetActiveUniformARB. This version returns only the uniform name.

### glGetActiveUniformSizeARB

public static int glGetActiveUniformSizeARB(int programObj, int index)
Overloads glGetActiveUniformARB.

Overloads glGetActiveUniformARB. This version returns only the uniform size.

### glGetActiveUniformTypeARB

public static int glGetActiveUniformTypeARB(int programObj, int index)
Overloads glGetActiveUniformARB.

Overloads glGetActiveUniformARB. This version returns only the uniform type.

### glGetUniformARB

public static void glGetUniformARB(int programObj, int location, FloatBuffer params)

### glGetUniformARB

public static void glGetUniformARB(int programObj, int location, IntBuffer params)

### glGetShaderSourceARB

public static void glGetShaderSourceARB(int obj, IntBuffer length, ByteBuffer source)

### glGetShaderSourceARB

public static String glGetShaderSourceARB(int obj, int maxLength)
Overloads glGetShaderSourceARB.